//
//  ViewController.swift
//  CrossControl
//
//  Created by kunii on 2018/09/19.
//  Copyright © 2018年 Takahiro Kunii. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        let control = CrossControl(frame:CGRect(x: 50, y: 100, width: 200, height: 200))
        self.view.addSubview(control)
        
        control.addTarget(self, action: #selector(crossRegionHandler(_:)), for: [.valueChanged, .touchCancel, .touchUpInside, .touchUpOutside])
//        control.addTarget(self, action: #selector(enterExitHandler(_:)), for: [.touchDragEnter, .touchDragExit])
//        control.addTarget(self, action: #selector(crossDragInsideHandler(_:forEvent:)), for: .touchDragInside)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @objc func crossRegionHandler(_ control:CrossControl) {
        print("valueChanged \(control.region) \(control.isTracking) \(control.isTouchInside)")
    }

    /// コントロール領域の外に出た時と、中に入った時に通知してくる
    /// コントロール領域はコントロールのframeより大きめな点に注意
    @objc func enterExitHandler(_ control:CrossControl) {
        print("enter/exit")
    }
    
    /// コントロール領域内でドラッグによる指位置変化が起きれば通知してくる
    @objc func crossDragInsideHandler(_ control:CrossControl, forEvent event:UIEvent) {
        guard let t = event.touches(for: control)?.first else {
            return
        }
        print("DragInside \(t.location(in: control)) \(control.region) \(control.isTracking) \(control.isTouchInside)")
    }
}

